gtksourceviewmm: Gsv::LanguageManager Class Reference

gtksourceviewmm 3.18.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gsv::LanguageManager Class Reference

Class which provides access to SourceLanguages. More...

`#include <gtksourceviewmm/languagemanager.h>`

Inherits Glib::Object.

## Public Member Functions
| LanguageManager (LanguageManager&& src) noexcept
LanguageManager& | operator= (LanguageManager&& src) noexcept
| ~LanguageManager () noexcept override
GtkSourceLanguageManager* | gobj ()
| Provides access to the underlying C GObject.
const GtkSourceLanguageManager* | gobj () const
| Provides access to the underlying C GObject.
GtkSourceLanguageManager* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
std::vector< std::string > | get_search_path () const
| Gets the list directories where language manager looks for language files.
void | set_search_path (const std::vector< std::string >& dirs)
| Sets the list of directories where the language manager looks for language files.
void | reset_search_path ()
| Resets the list of directories where the language manager looks for language files to default.
std::vector< std::string > | get_language_ids () const
| Returns the ids of the available languages.
Glib::RefPtr< Language > | get_language (const std::string& id)
| Gets the Language identified by the given id in the language manager.
Glib::RefPtr< const Language > | get_language (const std::string& id) const
| Gets the Language identified by the given id in the language manager.
Glib::RefPtr< Language > | guess_language (const std::string& filename, const std::string& content_type)
| Picks a Language for given file name and content type, according to the information in lang files.
Glib::RefPtr< const Language > | guess_language (const std::string& filename, const std::string& content_type) const
| Picks a Language for given file name and content type, according to the information in lang files.
Glib::PropertyProxy< std::vector< std::string > > | property_search_path ()
| List of directories where the language specification files (.lang) are located.
Glib::PropertyProxy_ReadOnly< std::vector< std::string > > | property_search_path () const
| List of directories where the language specification files (.lang) are located.
Glib::PropertyProxy_ReadOnly< std::vector< std::string > > | property_language_ids () const
| List of the ids of the available languages.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< LanguageManager > | create ()
| Creates a new language manager.
static Glib::RefPtr< LanguageManager > | get_default ()
| Returns the default LanguageManager instance.

## Protected Member Functions
| LanguageManager ()

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gsv::LanguageManager > | wrap (GtkSourceLanguageManager* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Class which provides access to SourceLanguages.

LanguageManager is a class which processes language description files and creates and stores Language objects, and provides API to access them.

Use get_default() to retrieve the default instance of LanguageManager, and guess_language() to get a Language for given file name and content type.

## Constructor & Destructor Documentation

## ◆ LanguageManager() [1/2]

Gsv::LanguageManager::LanguageManager | ( | LanguageManager&& | src | ) |
| noexcept

## ◆ ~LanguageManager()

Gsv::LanguageManager::~LanguageManager | ( |  | ) |
| overridenoexcept

## ◆ LanguageManager() [2/2]

Gsv::LanguageManager::LanguageManager | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< LanguageManager > Gsv::LanguageManager::create | ( |  | ) |
| static

Creates a new language manager.

If you do not need more than one language manager or a private language manager instance then use get_default() instead.

Returns
  A LanguageManager.

## ◆ get_default()

static Glib::RefPtr< LanguageManager > Gsv::LanguageManager::get_default | ( |  | ) |
| static

Returns the default LanguageManager instance.

Returns
  A LanguageManager.

## ◆ get_language() [1/2]

Glib::RefPtr< Language > Gsv::LanguageManager::get_language | ( | const std::string & | id | ) |

Gets the Language identified by the given id in the language manager.

Parameters

  id | A language id.

Returns
  A Language, or empty Glib::RefPtr if there is no language identified by the given id.

## ◆ get_language() [2/2]

Glib::RefPtr< const Language > Gsv::LanguageManager::get_language | ( | const std::string & | id | ) | const

Gets the Language identified by the given id in the language manager.

Parameters

  id | A language id.

Returns
  A Language, or empty Glib::RefPtr if there is no language identified by the given id.

## ◆ get_language_ids()

std::vector< std::string > Gsv::LanguageManager::get_language_ids | ( |  | ) | const

Returns the ids of the available languages.

Returns
  An array of string containing the ids of the available languages.

## ◆ get_search_path()

std::vector< std::string > Gsv::LanguageManager::get_search_path | ( |  | ) | const

Gets the list directories where language manager looks for language files.

Returns
  An array containg a list of language files directories.

## ◆ get_type()

static GType Gsv::LanguageManager::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkSourceLanguageManager * Gsv::LanguageManager::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkSourceLanguageManager * Gsv::LanguageManager::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkSourceLanguageManager * Gsv::LanguageManager::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ guess_language() [1/2]

Glib::RefPtr< Language > Gsv::LanguageManager::guess_language | ( | const std::string & | filename,
|  | const std::string & | content_type )

Picks a Language for given file name and content type, according to the information in lang files.

Either filename or content_type may be an empty string. This function can be used as follows:

Glib::RefPtr<Language> lang;
lang = lm->guess_language(filename, Glib::ustring());
buffer->set_language(lang);

or

Glib::RefPtr<Language> lang;
bool result_uncertain = FALSE;
Glib::ustring content_type;
content_type = Gio::content_type_guess(filename, 0, 0, &result_uncertain);
if (result_uncertain)
{
content_type.clear();
}
lang = lm->guess_language(filename, content_type);
buffer->set_language(lang);

etc. Use get_mime_types() and get_globs() if you need full control over file -> language mapping.

Parameters

  filename | A filename, or empty string.
  content_type | A content type (as in GIO API), or empty string.

Returns
  A Language, or empty Glib::RefPtr if there is no suitable language for given filename and/or content_type.

## ◆ guess_language() [2/2]

Glib::RefPtr< const Language > Gsv::LanguageManager::guess_language | ( | const std::string & | filename,
|  | const std::string & | content_type ) const

Picks a Language for given file name and content type, according to the information in lang files.

Either filename or content_type may be an empty string. This function can be used as follows:

Glib::RefPtr<LanguageManager> lm = LanguageManager::get_default();
Glib::RefPtr<Language> lang;
Glib::RefPtr<Buffer> buffer = Buffer::create();
lang = lm->guess_language(filename, Glib::ustring());
buffer->set_language(lang);
// or just:
// Glib::RefPtr<Buffer> buffer = Buffer::create(lang);
Gsv::Buffer::create
static Glib::RefPtr< Buffer > create()
Create a new source buffer.
Gsv::LanguageManager::get_default
static Glib::RefPtr< LanguageManager > get_default()
Returns the default LanguageManager instance.

or

Glib::RefPtr<Language> lang;
Glib::RefPtr<LanguageManager> lm = LanguageManager::get_default();
Glib::RefPtr<Buffer> buffer = Buffer::create();
bool result_uncertain = FALSE;
Glib::ustring content_type;
content_type = Gio::content_type_guess(filename, 0, 0, &result_uncertain);
if (result_uncertain)
{
content_type.clear();
}
lang = lm->guess_language(filename, content_type);
buffer->set_language(lang);
// or just:
// Glib::RefPtr<Buffer> buffer = Buffer::create(lang);

etc. Use Language::get_mime_types() and Language::get_globs() if you need full control over file -> language mapping.

Parameters

  filename | A filename, or empty string.
  content_type | A content type (as in GIO API), or empty string.

Returns
  A Language, or empty Glib::RefPtr if there is no suitable language for given filename and/or content_type.

## ◆ operator=()

LanguageManager& Gsv::LanguageManager::operator= | ( | LanguageManager&& | src | ) |
| noexcept

## ◆ property_language_ids()

Glib::PropertyProxy_ReadOnly< std::vector< std::string > > Gsv::LanguageManager::property_language_ids | ( |  | ) | const

List of the ids of the available languages.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_search_path() [1/2]

Glib::PropertyProxy< std::vector< std::string > > Gsv::LanguageManager::property_search_path | ( |  | ) |

List of directories where the language specification files (.lang) are located.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_search_path() [2/2]

Glib::PropertyProxy_ReadOnly< std::vector< std::string > > Gsv::LanguageManager::property_search_path | ( |  | ) | const

List of directories where the language specification files (.lang) are located.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ reset_search_path()

void Gsv::LanguageManager::reset_search_path | ( |  | ) |

Resets the list of directories where the language manager looks for language files to default.

Note
  At the moment this function can be called only before the language files are loaded for the first time. In practice to set a custom search path for a LanguageManager, you have to call this function right after creating it.

## ◆ set_search_path()

void Gsv::LanguageManager::set_search_path | ( | const std::vector< std::string > & | dirs | ) |

Sets the list of directories where the language manager looks for language files.

Note
  At the moment this function can be called only before the language files are loaded for the first time. In practice to set a custom search path for a LanguageManager, you have to call this function right after creating it.

Parameters

  dirs | An empty string terminated array of strings.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gsv::LanguageManager > wrap | ( | GtkSourceLanguageManager * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.